typedef struct
{
	BYTE textureName[8];

	WORD width, height;
	BYTE **pVertLines;

	// The mask to use for this texture (so it doesn't go over the end).
	Fixed xTextureMask;
	
	// What to shift a u (0-1) value by to get a value between 0 and width in this texture.
	WORD xTextureShift;
} Texture;


// Searches all the loaded textures for the one with that name.
TextureID tx_GetIDFromName( BYTE *pSearchName );

// Returns a pointer to the texture with the given index.
Texture *tx_GetTexture( TextureID index );

// Appends a new texture .. fills in the ID and returns a pointer to the new
// texture.  Whatever calls this should fill in the texture data.
Texture *tx_AddTexture( TextureID *idNewTexture );

// Just draws a texture on the screen..
BOOL tx_DrawTexture( TextureID idToDraw );

BOOL tx_UnloadTextures();




